package com.huimv.eartag.manager.pojo;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/****
 * @Author:shenkunlin
 * @Description:EartagData构建
 * @Date 2019/6/14 19:13
 *****/
@Table(name="eartag_data")
public class EartagData implements Serializable{
	@Override
	public String toString() {
		return "EartagData{" +
				"id=" + id +
				", header='" + header + '\'' +
				", SBID=" + SBID +
				", CMD=" + CMD +
				", version='" + version + '\'' +
				", serial=" + serial +
				", eartagId='" + eartagId + '\'' +
				", dl=" + dl +
				", NBWD=" + NBWD +
				", EBWD=" + EBWD +
				", ntc=" + ntc +
				", YDL=" + YDL +
				", CQS=" + CQS +
				", RSSYI=" + RSSYI +
				", timestamp=" + timestamp +
				", checkNumber=" + checkNumber +
				", MLW='" + MLW + '\'' +
				'}';
	}

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
	private Integer id;//

	@Column(name = "header")
	private String header;//设备id

    @Column(name = "SBID")
	private Integer SBID;//设备id

    @Column(name = "CMD")
	private Integer CMD;//命令

    @Column(name = "version")
	private String version;//版本

    @Column(name = "serial")
	private Integer serial;//序列号

    @Column(name = "eartag_id")
	private String eartagId;//耳标id

    @Column(name = "dl")
	private Integer dl;//电量

    @Column(name = "NBWD")
	private Integer NBWD;//内部温度

    @Column(name = "EBWD")
	private Double EBWD;//耳标温度

    @Column(name = "ntc")
	private Integer ntc;//ntc

    @Column(name = "YDL")
	private Integer YDL;//运动量

	@Column(name = "qjydl")
	private Integer qjydl;//


    @Column(name = "CQS")
	private Integer CQS;//重启数

    @Column(name = "RSSYI")
	private Integer RSSYI;//rssi

    @Column(name = "timestamp")
	private Date timestamp;//时间戳

    @Column(name = "check_number")
	private Integer checkNumber;//校验码

    @Column(name = "MLW")
	private String MLW;//命令尾

	public Integer getQjydl() {
		return qjydl;
	}

	public void setQjydl(Integer qjydl) {
		this.qjydl = qjydl;
	}

	//get方法
	public Integer getId() {
		return id;
	}

	//set方法
	public void setId(Integer id) {
		this.id = id;
	}
	//get方法
	public Integer getSBID() {
		return SBID;
	}

	//set方法
	public void setSBID(Integer SBID) {
		this.SBID = SBID;
	}
	//get方法
	public Integer getCMD() {
		return CMD;
	}

	//set方法
	public void setCMD(Integer CMD) {
		this.CMD = CMD;
	}
	//get方法
	public String getVersion() {
		return version;
	}

	//set方法
	public void setVersion(String version) {
		this.version = version;
	}
	//get方法
	public Integer getSerial() {
		return serial;
	}

	//set方法
	public void setSerial(Integer serial) {
		this.serial = serial;
	}
	//get方法
	public String getEartagId() {
		return eartagId;
	}

	//set方法
	public void setEartagId(String eartagId) {
		this.eartagId = eartagId;
	}
	//get方法
	public Integer getDl() {
		return dl;
	}

	//set方法
	public void setDl(Integer dl) {
		this.dl = dl;
	}
	//get方法
	public Integer getNBWD() {
		return NBWD;
	}

	//set方法
	public void setNBWD(Integer NBWD) {
		this.NBWD = NBWD;
	}
	//get方法
	public Double getEBWD() {
		return EBWD;
	}

	//set方法
	public void setEBWD(Double EBWD) {
		this.EBWD = EBWD;
	}
	//get方法
	public Integer getNtc() {
		return ntc;
	}

	//set方法
	public void setNtc(Integer ntc) {
		this.ntc = ntc;
	}
	//get方法
	public Integer getYDL() {
		return YDL;
	}

	//set方法
	public void setYDL(Integer YDL) {
		this.YDL = YDL;
	}
	//get方法
	public Integer getCQS() {
		return CQS;
	}

	//set方法
	public void setCQS(Integer CQS) {
		this.CQS = CQS;
	}
	//get方法
	public Integer getRSSYI() {
		return RSSYI;
	}

	//set方法
	public void setRSSYI(Integer RSSYI) {
		this.RSSYI = RSSYI;
	}
	//get方法
	public Date getTimestamp() {
		return timestamp;
	}

	//set方法
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
	//get方法
	public Integer getCheckNumber() {
		return checkNumber;
	}

	//set方法
	public void setCheckNumber(Integer checkNumber) {
		this.checkNumber = checkNumber;
	}
	//get方法
	public String getMLW() {
		return MLW;
	}

	//set方法
	public void setMLW(String MLW) {
		this.MLW = MLW;
	}


	public String getHeader() {
		return header;
	}

	public void setHeader(String header) {
		this.header = header;
	}
}
