package com.huimv.eartag.manager.service;




import com.github.pagehelper.PageInfo;
import com.huimv.eartag.manager.pojo.EartagData;

import java.util.List;
import java.util.Map;

/****
 * @Author:shenkunlin
 * @Description:EartagData业务层接口
 * @Date 2019/6/14 0:16
 *****/
public interface EartagDataService {

    /***
     * EartagData多条件分页查询
     * @param eartagData
     * @param page
     * @param size
     * @return
     */
    PageInfo<Map> findPage(Map eartagData, int page, int size);

    /***
     * EartagData分页查询
     * @param page
     * @param size
     * @return
     */
    PageInfo<EartagData> findPage(int page, int size);

    /***
     * EartagData多条件搜索方法
     * @param eartagData
     * @return
     */
    List<EartagData> findList(EartagData eartagData);

    /***
     * 删除EartagData
     * @param id
     */
    void delete(Integer id);

    /***
     * 修改EartagData数据
     * @param eartagData
     */
    void update(EartagData eartagData);

    /***
     * 新增EartagData
     * @param eartagData
     */
    void add(EartagData eartagData);

    /**
     * 根据ID查询EartagData
     * @param id
     * @return
     */
     EartagData findById(Integer id);

    /***
     * 查询所有EartagData
     * @return
     */
    List<EartagData> findAll();

    Map searchData(Map map);
}
