package com.huimv.eartag.manager.service;

import com.github.pagehelper.PageInfo;
import com.huimv.eartag.manager.pojo.Jqid;

import java.util.List;
import java.util.Map;

/****
 * @Author:shenkunlin
 * @Description:Jqid业务层接口
 * @Date 2019/6/14 0:16
 *****/
public interface JqidService {

    /***
     * Jqid多条件分页查询
     * @param jqid
     * @param page
     * @param size
     * @return
     */
    PageInfo<Jqid> findPage(Jqid jqid, int page, int size);

    /***
     * Jqid分页查询
     * @param page
     * @param size
     * @return
     */
    PageInfo<Jqid> findPage(int page, int size);

    /***
     * Jqid多条件搜索方法
     * @param jqid
     * @return
     */
    List<Jqid> findList(Jqid jqid);

    /***
     * 删除Jqid
     * @param id
     */
    void delete(Integer id);

    /***
     * 修改Jqid数据
     * @param jqid
     */
    void update(Jqid jqid);

    /***
     * 新增Jqid
     * @param jqid
     */
    void add(Jqid jqid);

    /**
     * 根据ID查询Jqid
     * @param id
     * @return
     */
     Jqid findById(Integer id);

    /***
     * 查询所有Jqid
     * @return
     */
    List<Jqid> findAll();

    /**
     * @Method      : findDeviceIdByJQcode
     * @Description : 
     * @Params      : [serialNo]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/16       
     * @Time        : 18:36
     */
    String findDeviceIdByJQcode(String serialNo);

    Map searchData(Map map);
}
