package com.huimv.eartag.manager.service.impl;


import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import com.huimv.eartag.manager.dao.EartagDampnessMapper;
import com.huimv.eartag.manager.pojo.EartagDampness;
import com.huimv.eartag.manager.service.EartagDampnessService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import tk.mybatis.mapper.entity.Example;

import java.util.List;

/****
 * @Author:shenkunlin
 * @Description:EartagDampness业务层接口实现类
 * @Date 2019/6/14 0:16
 *****/
@Service
public class EartagDampnessServiceImpl implements EartagDampnessService {

    @Autowired
    private EartagDampnessMapper eartagDampnessMapper;


    /**
     * EartagDampness条件+分页查询
     * @param eartagDampness 查询条件
     * @param page 页码
     * @param size 页大小
     * @return 分页结果
     */
    @Override
    public PageInfo<EartagDampness> findPage(EartagDampness eartagDampness, int page, int size){
        //分页
        PageHelper.startPage(page,size);
        //搜索条件构建
        Example example = createExample(eartagDampness);
        //执行搜索
        return new PageInfo<EartagDampness>(eartagDampnessMapper.selectByExample(example));
    }

    /**
     * EartagDampness分页查询
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<EartagDampness> findPage(int page, int size){
        //静态分页
        PageHelper.startPage(page,size);
        //分页查询
        return new PageInfo<EartagDampness>(eartagDampnessMapper.selectAll());
    }

    /**
     * EartagDampness条件查询
     * @param eartagDampness
     * @return
     */
    @Override
    public List<EartagDampness> findList(EartagDampness eartagDampness){
        //构建查询条件
        Example example = createExample(eartagDampness);
        //根据构建的条件查询数据
        return eartagDampnessMapper.selectByExample(example);
    }


    /**
     * EartagDampness构建查询对象
     * @param eartagDampness
     * @return
     */
    public Example createExample(EartagDampness eartagDampness){
        Example example=new Example(EartagDampness.class);
        Example.Criteria criteria = example.createCriteria();
        if(eartagDampness!=null){
            // 
            if(!StringUtils.isEmpty(eartagDampness.getId())){
                    criteria.andEqualTo("id",eartagDampness.getId());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getHeader())){
                    criteria.andEqualTo("header",eartagDampness.getHeader());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getDeviceId())){
                    criteria.andEqualTo("deviceId",eartagDampness.getDeviceId());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getCmd())){
                    criteria.andEqualTo("cmd",eartagDampness.getCmd());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getSerialNo())){
                    criteria.andEqualTo("serialNo",eartagDampness.getSerialNo());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getValue())){
                    criteria.andEqualTo("value",eartagDampness.getValue());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getCreateDate())){
                    criteria.andEqualTo("createDate",eartagDampness.getCreateDate());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getCheckNumber())){
                    criteria.andEqualTo("checkNumber",eartagDampness.getCheckNumber());
            }
            // 
            if(!StringUtils.isEmpty(eartagDampness.getTail())){
                    criteria.andEqualTo("tail",eartagDampness.getTail());
            }
        }
        return example;
    }

    /**
     * 删除
     * @param id
     */
    @Override
    public void delete(Integer id){
        eartagDampnessMapper.deleteByPrimaryKey(id);
    }

    /**
     * 修改EartagDampness
     * @param eartagDampness
     */
    @Override
    public void update(EartagDampness eartagDampness){
        eartagDampnessMapper.updateByPrimaryKey(eartagDampness);
    }

    /**
     * 增加EartagDampness
     * @param eartagDampness
     */
    @Override
    public void add(EartagDampness eartagDampness){
        eartagDampnessMapper.insert(eartagDampness);
    }

    /**
     * 根据ID查询EartagDampness
     * @param id
     * @return
     */
    @Override
    public EartagDampness findById(Integer id){
        return  eartagDampnessMapper.selectByPrimaryKey(id);
    }

    /**
     * 查询EartagDampness全部数据
     * @return
     */
    @Override
    public List<EartagDampness> findAll() {
        return eartagDampnessMapper.selectAll();
    }
}
