package com.huimv.eartag.manager.service.impl;



import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.huimv.eartag.manager.dao.EartagDataMapper;
import com.huimv.eartag.manager.pojo.EartagData;
import com.huimv.eartag.manager.service.EartagDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import tk.mybatis.mapper.entity.Example;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/****
 * @Author:shenkunlin
 * @Description:EartagData业务层接口实现类
 * @Date 2019/6/14 0:16
 *****/
@Service
public class EartagDataServiceImpl implements EartagDataService {

    @Autowired
    private EartagDataMapper eartagDataMapper;


    /**
     * EartagData条件+分页查询
     * @param map 查询条件
     * @param page 页码
     * @param size 页大小
     * @return 分页结果
     */
    @Override
    public PageInfo<Map> findPage(Map map, int page, int size){
        List<EartagData>  list = new ArrayList();
        page = (page-1 )*size;
        String eartag = (String)map.get("eartagId");
        String  startTime = (String) map.get("startTime");
        String  endTime = (String) map.get("endTime");
        if (map.get("SBID")!=null && !"".equals(map.get("SBID"))) {
            Integer SBID = Integer.parseInt((String) map.get("SBID"));
            if (eartag == null || eartag.equals("")){
                list = eartagDataMapper.selectByEartag3(SBID, startTime, endTime, page, size);
            }else {
                list = eartagDataMapper.selectByEartag(SBID, eartag, startTime, endTime, page, size);
            }
        }else {
            if (eartag == null || eartag.equals("")){
                list = eartagDataMapper.selectByEartag2( startTime, endTime, page, size);
            }else {
                list = eartagDataMapper.selectByEartag1( eartag, startTime, endTime, page, size);

            }

        }
        List list2 = new ArrayList();
        for (EartagData eartagData : list) {
            Example example = createExample(eartagData);
            List<EartagData> eartagData1 = eartagDataMapper.selectByExample(example);
            list2.add(eartagData1.get(0));
        }

        list2 =timeUtil(list2);

        return new PageInfo<>(list2);
    }
//    @Override
//    public PageInfo<Map> findPage(Map map, int page, int size){
//        PageInfo<Map> eartagDataPageInfo=null;
//        EartagData eartagData = new EartagData();
//        if (map != null){
//            /*eartagData.setCheckNumber((Integer) map.get("checkNumber"));
//            eartagData.setCMD((Integer) map.get("cmd"));
//            eartagData.setCQS((Integer)map.get("cqs"));
//            eartagData.setDl((Integer)map.get("dl"));
//
//            eartagData.setEBWD((Double) map.get("ebwd"));
//            eartagData.setHeader((String)map.get("header"));
//            eartagData.setId((Integer)map.get("id"));
//            eartagData.setMLW((String) map.get("mlw"));
//            eartagData.setNBWD((Integer)map.get("nbwd"));
//            eartagData.setNtc((Integer)map.get("ntc"));
//            eartagData.setRSSYI((Integer)map.get("rssyi"));*/
//            eartagData.setEartagId((String) map.get("eartagId"));
//            if (map.get("SBID")!=null && !"".equals(map.get("SBID"))) {
//                eartagData.setSBID(Integer.parseInt((String)map.get("SBID")));
//            }
//           /* eartagData.setSerial((Integer)map.get("serial"));
//            // eartagData.setTimestamp((Date) map.get("timestamp"));
//            eartagData.setVersion((String)map.get("version"));
//            eartagData.setYDL((Integer)map.get("ydl"));*/
//
//            String  startTime1 = (String) map.get("startTime");
//            String  endTime1 = (String) map.get("endTime");
//            DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
//            if (startTime1 != null && endTime1 != null){
//
//                Date startTime = null;
//                Date endTime = null;
//                try {
//                    startTime =fmt.parse(startTime1);
//                    endTime = fmt.parse(endTime1);
//                } catch (ParseException e) {
//                    e.printStackTrace();
//                }
//
//                //分页
//               // PageHelper.startPage(page,size);
//                //搜索条件构建
//                Example example = createExample(eartagData);
//                List<EartagData> eartagData1 = eartagDataMapper.selectByExample(example);
//                List list3 = utils(eartagData1,startTime,endTime);
//
//                List resultList = timeUtil(list3);
//
//
//                eartagDataPageInfo = new PageInfo<>(resultList);
//            }else {
//                //PageHelper.startPage(page,size);
//                //搜索条件构建
//                Example example = createExample(eartagData);
//                List<EartagData> eartagData1 = eartagDataMapper.selectByExample(example);
//
//                eartagDataPageInfo = new PageInfo<>(timeUtil( utils(eartagData1,null,null)));
//            }
//
//
//        }else {
//            //分页
//           // PageHelper.startPage(page,size);
//            //搜索条件构建
//            Example example = createExample(eartagData);
//            List<EartagData> eartagData1 = eartagDataMapper.selectByExample(example);
//            List utils = utils(eartagData1, null, null);
//            List list = timeUtil(utils);
//            eartagDataPageInfo = new PageInfo<>(list);
//            System.out.println("ssss");
//        }
//
//        return eartagDataPageInfo;
//    }
    @Override
    public Map searchData(Map map) {
        EartagData eartagData = new EartagData();
        eartagData.setEartagId((String) map.get("eartagId"));
        if (map.get("SBID")!=null && !"".equals(map.get("SBID"))) {
            eartagData.setSBID(Integer.parseInt((String)map.get("SBID")));
        }
        String  startTime1 = (String) map.get("startTime");
        String  endTime1 = (String) map.get("endTime");
        DateFormat fmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Map map1 = new HashMap();
        if (startTime1 != null && endTime1 != null) {

            Date startTime = null;
            Date endTime = null;
            try {
                startTime = fmt.parse(startTime1);
                endTime = fmt.parse(endTime1);
            } catch (ParseException e) {
                e.printStackTrace();
            }

            Example example = createExample(eartagData);
            List<EartagData> eartagData1 = eartagDataMapper.selectByExample(example);
            List<EartagData> list = new ArrayList();
            for (EartagData data : eartagData1) {
                Date timestamp = data.getTimestamp();
                if (startTime.before(timestamp) && endTime.after(timestamp)){
                    list.add(data);
                }
            }
            List timeList = new ArrayList();
            List tempList = new ArrayList();
            List sportsList = new ArrayList();
            List electricList = new ArrayList();

            for (EartagData data : list) {
                timeList.add(fmt.format(data.getTimestamp()));
                tempList.add(data.getEBWD());
                if (data.getQjydl() == null) {
                    sportsList.add(0);
                } else {
                    sportsList.add(data.getQjydl());
                }
                electricList.add(data.getDl());
            }
            map1.put("time",timeList);
            map1.put("temp",tempList);
            map1.put("sports",sportsList);
            map1.put("electric",electricList);

        }


        return map1;
    }



    public List<Map> timeUtil(List<EartagData> list){
        List<Map> list1 = new ArrayList();
        for (EartagData eartagData : list) {
            Date timestamp = eartagData.getTimestamp();
            SimpleDateFormat sfm1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = sfm1.format(timestamp);
            Map map =new HashMap();
            map.put("id",eartagData.getId());
            map.put("header",eartagData.getHeader());
            map.put("version",eartagData.getVersion());
            map.put("serial",eartagData.getSerial());
            map.put("eartagId",eartagData.getEartagId());
            map.put("dl",eartagData.getDl());
            map.put("ntc",eartagData.getNtc());
            map.put("timestamp",format);
            map.put("checkNumber",eartagData.getCheckNumber());
            map.put("mlw",eartagData.getMLW());
            map.put("ydl",eartagData.getYDL());
            map.put("ebwd",eartagData.getEBWD());
            map.put("cmd",eartagData.getCMD());
            map.put("rssyi",eartagData.getRSSYI());
            map.put("cqs",eartagData.getCQS());
            map.put("sbid",eartagData.getSBID());
            map.put("nbwd",eartagData.getNBWD());
            map.put("qjydl",eartagData.getQjydl());
            list1.add(map);
        }
        return list1;
    }

    /**
     * EartagData分页查询
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<EartagData> findPage(int page, int size){
        //静态分页
        PageHelper.startPage(page,size);
        //分页查询
        return new PageInfo<EartagData>(eartagDataMapper.selectAll());
    }

    /**
     * EartagData条件查询
     * @param eartagData
     * @return
     */
    @Override
    public List<EartagData> findList(EartagData eartagData){
        //构建查询条件
        Example example = createExample(eartagData);
        //根据构建的条件查询数据
        return eartagDataMapper.selectByExample(example);
    }


    /**
     * EartagData构建查询对象
     * @param eartagData
     * @return
     */
    public Example createExample(EartagData eartagData){
        Example example=new Example(EartagData.class);
        Example.Criteria criteria = example.createCriteria();
        if(eartagData!=null){
            // 
            if(!StringUtils.isEmpty(eartagData.getId())){
                    criteria.andEqualTo("id",eartagData.getId());
            }
            // 设备id
            if(!StringUtils.isEmpty(eartagData.getSBID())){
                    criteria.andEqualTo("SBID",eartagData.getSBID());
            }
            // 命令
            if(!StringUtils.isEmpty(eartagData.getCMD())){
                    criteria.andEqualTo("CMD",eartagData.getCMD());
            }
            // 版本
            if(!StringUtils.isEmpty(eartagData.getVersion())){
                    criteria.andEqualTo("version",eartagData.getVersion());
            }
            // 序列号
            if(!StringUtils.isEmpty(eartagData.getSerial())){
                    criteria.andEqualTo("serial",eartagData.getSerial());
            }
            // 耳标id
            if(!StringUtils.isEmpty(eartagData.getEartagId())){
                    criteria.andEqualTo("eartagId",eartagData.getEartagId());
            }
            // 电量
            if(!StringUtils.isEmpty(eartagData.getDl())){
                    criteria.andEqualTo("dl",eartagData.getDl());
            }
            // 内部温度
            if(!StringUtils.isEmpty(eartagData.getNBWD())){
                    criteria.andEqualTo("NBWD",eartagData.getNBWD());
            }
            // 耳标温度
            if(!StringUtils.isEmpty(eartagData.getEBWD())){
                    criteria.andEqualTo("EBWD",eartagData.getEBWD());
            }
            // ntc
            if(!StringUtils.isEmpty(eartagData.getNtc())){
                    criteria.andEqualTo("ntc",eartagData.getNtc());
            }
            // 运动量
            if(!StringUtils.isEmpty(eartagData.getYDL())){
                    criteria.andEqualTo("YDL",eartagData.getYDL());
            }
            // 重启数
            if(!StringUtils.isEmpty(eartagData.getCQS())){
                    criteria.andEqualTo("CQS",eartagData.getCQS());
            }
            // rssi
            if(!StringUtils.isEmpty(eartagData.getRSSYI())){
                    criteria.andEqualTo("RSSYI",eartagData.getRSSYI());
            }
            // 时间戳
            if(!StringUtils.isEmpty(eartagData.getTimestamp())){
                    criteria.andEqualTo("timestamp",eartagData.getTimestamp());
            }
            // 校验码
            if(!StringUtils.isEmpty(eartagData.getCheckNumber())){
                    criteria.andEqualTo("checkNumber",eartagData.getCheckNumber());
            }
            // 命令尾
            if(!StringUtils.isEmpty(eartagData.getMLW())){
                    criteria.andEqualTo("MLW",eartagData.getMLW());
            }
        }
        return example;
    }

    /**
     * 删除
     * @param id
     */
    @Override
    public void delete(Integer id){
        eartagDataMapper.deleteByPrimaryKey(id);
    }

    /**
     * 修改EartagData
     * @param eartagData
     */
    @Override
    public void update(EartagData eartagData){
        eartagDataMapper.updateByPrimaryKey(eartagData);
    }

    /**
     * 增加EartagData
     * @param eartagData
     */
    @Override
    public void add(EartagData eartagData){
        eartagDataMapper.insert(eartagData);
    }

    /**
     * 根据ID查询EartagData
     * @param id
     * @return
     */
    @Override
    public EartagData findById(Integer id){
        return  eartagDataMapper.selectByPrimaryKey(id);
    }

    /**
     * 查询EartagData全部数据
     * @return
     */
    @Override
    public List<EartagData> findAll() {
        return eartagDataMapper.selectAll();
    }


}
