package com.huimv.eartag.monitor.service;


import com.github.pagehelper.PageInfo;
import com.huimv.eartag.monitor.pojo.EartagTemperature;

import java.util.List;

/****
 * @Author:shenkunlin
 * @Description:EartagTemperature业务层接口
 * @Date 2019/6/14 0:16
 *****/
public interface EartagTemperatureService {

    /***
     * EartagTemperature多条件分页查询
     * @param eartagTemperature
     * @param page
     * @param size
     * @return
     */
    PageInfo<EartagTemperature> findPage(EartagTemperature eartagTemperature, int page, int size);

    /***
     * EartagTemperature分页查询
     * @param page
     * @param size
     * @return
     */
    PageInfo<EartagTemperature> findPage(int page, int size);

    /***
     * EartagTemperature多条件搜索方法
     * @param eartagTemperature
     * @return
     */
    List<EartagTemperature> findList(EartagTemperature eartagTemperature);

    /***
     * 删除EartagTemperature
     * @param id
     */
    void delete(Integer id);

    /***
     * 修改EartagTemperature数据
     * @param eartagTemperature
     */
    void update(EartagTemperature eartagTemperature);

    /***
     * 新增EartagTemperature
     * @param eartagTemperature
     */
    void add(EartagTemperature eartagTemperature);

    /**
     * 根据ID查询EartagTemperature
     * @param id
     * @return
     */
     EartagTemperature findById(Integer id);

    /***
     * 查询所有EartagTemperature
     * @return
     */
    List<EartagTemperature> findAll();
}
