package com.huimv.eartag.monitor.service;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.text.ParseException;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RunWith(SpringRunner.class)
@SpringBootTest
public class ParseClientMessageTest {

    @Autowired
    private IClientDataPacketService iParseClientPacket;

    @Test
    public void testParseClientMessage() throws ParseException {
        String clientMessage = "hm+123456789012345+1+7+end";
        String t = iParseClientPacket.handleClientSendPacket(clientMessage);
        System.out.println("t>>" + t);
    }

    @Test
    public void testHandleEartagData() throws ParseException {
        String clientMessage = "hm+0+6+1.0+002d4895+668519+89+2100+10902+1550+2+84+20201230175903+9+end";
        String t = iParseClientPacket.handleClientSendPacket(clientMessage).toString();
        System.out.println("测试结果>>" + t);
    }

    @Test
    public void testGetServerDateTime() throws ParseException {
    String clientMessage = "hm+158+2+9+end";
    String t = iParseClientPacket.handleClientSendPacket(clientMessage).toString();
        System.out.println("测试结果>>"+t);
    }

    /**
     * @Method      : testGetDeviceId
     * @Description : 
     * @Params      : []
     * @Return      : void
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/18       
     * @Time        : 11:07
     */
    @Test
    public void testGetDeviceId() throws ParseException {
        String clientMessage = "hm+123456789012345+1+7+end";
        String t = iParseClientPacket.handleClientSendPacket(clientMessage).toString();
        System.out.println("测试结果>>"+t);
    }

    @Test
    public void testHandleEartagTemperature() throws ParseException {
        String clientMessage = "hm+158+4+1+289+20170208152300+6+end";
        String t = iParseClientPacket.handleClientSendPacket(clientMessage).toString();
        System.out.println("测试结果>>"+t);
    }
}
